﻿using C1.Silverlight.FlexGrid;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace FG_MultiLineCopy
{
    public partial class MainPage : UserControl
    {
        private List<List<string>> CopyData = new List<List<string>>();

        public MainPage()
        {
            InitializeComponent();
            for (int c = 0; c < 4; c++)
            {
                fg.Columns.Add(new Column());
            }
            for (int r = 0; r < 10; r++)
            {
                fg.Rows.Add(new Row());
                for (int c = 0; c < 2; c++)
                {
                    fg[r, c] = string.Format("{0} MultiLine \n{1} Text\n ", r, c);
                }
            }
            fg.Loaded += new RoutedEventHandler(fg_Loaded);
            fg.PreviewKeyDown += new KeyEventHandler(fg_PreviewKeyDown);
            
         
         }
        void fg_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.C && Keyboard.Modifiers == ModifierKeys.Control)
            {
                e.Handled = true;
                CopyData.Clear();
                for (int r = fg.Selection.TopRow; r <= fg.Selection.BottomRow; r++)
                {
                    CopyData.Add(new List<string>());
                    for (int c = fg.Selection.LeftColumn; c <= fg.Selection.RightColumn; c++)
                    {
                        CopyData[r - fg.Selection.TopRow].Add(fg[r, c].ToString());
                    }
                }
            }
            else if (e.Key == Key.V && Keyboard.Modifiers == ModifierKeys.Control)
            {
                e.Handled = true;
                for (int r = 0; r < CopyData.Count && fg.Selection.Row + r < fg.Rows.Count; r++)
                {
                    for (int c = 0; c < CopyData[r].Count && fg.Selection.Column + c < fg.Columns.Count; c++)
                    {
                        fg[fg.Selection.Row + r, fg.Selection.Column + c] = CopyData[r][c];
                    }
                }
            }
        }
        void fg_Loaded(object sender, RoutedEventArgs e)
        {
            Dispatcher.BeginInvoke(() =>
            {
                fg.AutoSizeRows(0, fg.Rows.Count - 1, 0);
            });
        }
    }
}
